﻿using System;
using System.Windows;
using Ecng.Common;
using StockSharp.Logging;

namespace WpfApp2
{
    /// <summary>
    /// Логика взаимодействия для TestSourceWindow.xaml
    /// </summary>
    public partial class TestSourceWindow : Window, ILogSource
    {
        public Guid Id { get; }
        public LogLevels LogLevel { get; set; }
        public DateTimeOffset CurrentTime => DateTimeOffset.Now;
        public bool IsRoot { get; }
        public ILogSource Parent { get; set; }
        public event Action<LogMessage> Log;

        public TestSourceWindow()
        {
            InitializeComponent();
            Loaded += TestSourceWindow_Loaded;
        }

        /// <summary>
        /// Выводим 10 сообщений дочернего окна
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void TestSourceWindow_Loaded(object sender, RoutedEventArgs e)
        {
            for (var i = 0; i < 10; i++)
            {
                var level = RandomGen.GetEnum<LogLevels>();

                switch (level)
                {
                    case LogLevels.Verbose:
                    case LogLevels.Inherit:
                    case LogLevels.Debug:
                    case LogLevels.Info:
                    case LogLevels.Off:
                        Log?.Invoke(new LogMessage(this, CurrentTime, LogLevel, $"Сообщение дочернего окна {level}"));
                        break;
                    case LogLevels.Warning:
                        Log?.Invoke(new LogMessage(this, CurrentTime, LogLevel, $"Сообщение дочернего окна {level}"));
                        break;
                    case LogLevels.Error:
                        Log?.Invoke(new LogMessage(this, CurrentTime, LogLevel, $"Сообщение дочернего окна {level}"));
                        break;
                    default:
                        throw new ArgumentOutOfRangeException();
                }

            }
        }

        public void Dispose()
        {
            throw new NotImplementedException();
        }
    }
}
